<template>
<div class="todo-item">
     <div class="todo-item-left">
        <input type="checkbox" v-model="completed" @change="doneEdit">
        <!-- Kvůli editaci pridám v-if a listener dblclick a upravím dole v metodách, :class mi přidá class pokud je stav completed true-->
        <!-- 2. když máme přenesená data už nepotřebujeme tu přeložku todo. a to v závorkách (todo) -->
        <div v-if="!editing" v-on:dblclick="editTodo" class="todo-item-label" :class="{ completed : completed}">{{title}}</div>
        <!-- kvůli editaci přidám v-else, blur ztráci focus při překliknutí -->
        <input v-else class="todo-item-edit" type="text" v-model="title" @blur="doneEdit" @keyup.enter="doneEdit" @keyup.esc="cancelEdit" v-focus>
    </div>
    <button @click="pluralize">Plural</button>
    <div class="remove-item" @click="removeTodo(todo.id)">x</div>
</div>
  
</template>

<script>
    export default {
        name: 'todo-item',
        props: {
            todo: {
            type: Object,
            required: true,
            },
            checkAll: {
            type: Boolean,
            required: true,
            }
        },
        data() {
            return {
            'id': this.todo.id,
            'title': this.todo.title,
            'completed': this.todo.completed,
            'editing': this.todo.editing,
            'beforeEditCache': '',
            }
        },
         created() {
            //eventBus.$on('pluralize', this.handlePluralize)
        },
        beforeDestroy() {
            //eventBus.$off('pluralize', this.handlePluralize)
        },
          directives: {
            focus: {
               mounted: (el) => el.focus()
            } 
           
        },
        watch: {
           checkAll() {
                this.completed = this.checkAll ? true : this.todo.completed
            }
        },
       
        methods: {
            removeTodo(id) {
            this.$store.dispatch('deleteTodo', id)
            },
            editTodo() {
            this.beforeEditCache = this.title
            this.editing = true
            },
            doneEdit() {
            if (this.title.trim() == '') {
                this.title = this.beforeEditCache
            }
            this.editing = false
            this.$store.dispatch('updateTodo', {
                'id': this.id,
                'title': this.title,
                'completed': this.completed,
                'editing': this.editing,
            })
            },
            cancelEdit() {
            this.title = this.beforeEditCache
            this.editing = false
            },
            pluralize() {
            //eventBus.$emit('pluralize')
            },
            handlePluralize() {
            this.title = this.title + 's'
            this.$store.dispatch('updateTodo', {
                'id': this.id,
                'title': this.title,
                'completed': this.completed,
                'editing': this.editing,
            })
        }
    }
}

</script>

<style lang="scss" scoped>

</style>